package component{
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;

//--------------------------------------------------------------------//
// R{{bNXNX
  public class ComboBox extends Sprite{

// Xg\ʒu㑤\
    public static const ABOVE:int=1;

// Xg\ʒu\
    public static const BELLOW:int=2;

// ICxg
    public static const SELECT:String="list_select";  

// IڃCfbNX
    public var index:int;

// Iڃx
    internal var selectedField:TextField;

// Xg\ؑ
    internal var showList:Boolean;

// ڃXg
    internal var labels:Vector.<String>;

// ڃXg\x
    internal var fields:Vector.<TextField>;

//--------------------------------------------------------------------//
// labels - ڃXg
// fgColor - OiF
// bgColor - wiF
// x,y - \ʒu
// textFormat - eLXg
// posit - Xg\ʒu
// index - IڃCfbNX
    public function ComboBox(labels:Vector.<String>,
      	      	      	     fgColor:uint,bgColor:uint,x:int,y:int,
      	      	      	     textFormat:TextFormat,posit:int,index:int=0){
      this.labels=labels;
      this.index=index;
      selectedField=new TextField();
      selectedField.defaultTextFormat=textFormat;
      selectedField.border=true;
      selectedField.textColor=fgColor;
      selectedField.borderColor=fgColor;
      selectedField.backgroundColor=bgColor;
      selectedField.selectable=false;
      selectedField.background=true;
      selectedField.text=labels[index];
      selectedField.x=x;
      selectedField.y=y;
      selectedField.height=selectedField.textHeight+TextBox.CL;
      var w:int=selectedField.textWidth+TextBox.CL;
      var yy:int=y+selectedField.height
      fields=new Vector.<TextField>(labels.length,true);
      for(var i:int=0;i<labels.length;i++){
      	fields[i]=new TextField();
      	fields[i].defaultTextFormat=textFormat;
      	fields[i].textColor=fgColor;
      	fields[i].backgroundColor=bgColor;
      	fields[i].selectable=false;
      	fields[i].background=true;
      	fields[i].text=labels[i];
      	fields[i].x=x;
      	fields[i].y=yy;
      	w=Math.max(w,fields[i].textWidth+TextBox.CL);
      	fields[i].height=fields[i].textHeight+TextBox.CL;
      	yy+=fields[i].height;
      }
      if(posit==ABOVE){
      	var dy:int=yy-y;
      	for(i=0;i<labels.length;i++){
      	  fields[i].y-=dy;
      	}
      }
      selectedField.width=w;
      for(i=0;i<labels.length;i++){
      	fields[i].width=w;
      }
      addChild(selectedField);
      showList=false;
      addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    public function mousePressed(event:MouseEvent):void{
      if(showList){
      	for(var i:int=0;i<labels.length;i++){
      	  removeChild(fields[i]);
      	}
      	var newIndex:int=mouseIndex();
      	if((newIndex>=0) && (index!=newIndex)){
      	  index=newIndex;
      	  selectedField.text=labels[index];
      	  dispatchEvent(new Event(SELECT));
      	}
      	showList=false;
      }
      else{
      	for(i=0;i<labels.length;i++){
      	  addChild(fields[i]);
      	}
      	showList=true;
      }
    }

//--------------------------------------------------------------------//
// }EX{^őIڂ̃CfbNXԂ
    protected function mouseIndex():int{
      var y:int=fields[0].y;
      if(mouseY<y) return -1;
      for(var i:int=0;i<labels.length;i++){
      	y+=fields[i].height;
      	if(mouseY<=y) return i;
      }
      return -1;
    }
  }
}
