package shading{
  import flash.geom.Vector3D;

//--------------------------------------------------------------------//
// tHfNX
  public class PhongModel implements LightModel{

// gUˌW
    protected var kd:Number;

// ʔˌW
    protected var ks:Number;

// ʔ˂̋xW
    protected var ns:int;

// W
    protected var ke:Number;

//--------------------------------------------------------------------//
// tHf\z
// kd - gUˌW
// ks - ʔˌW
// ns - ʔ˂̋xW
// ke - W
    public function PhongModel(kd:Number,ks:Number,ns:int,
      	      	      	       ke:Number):void{
      this.kd=kd;
      this.ks=ks;
      this.ns=ns;
      this.ke=ke;
    }

//--------------------------------------------------------------------//
// ˌvZĕ\FԂ
// viewVector - xNg
// lightVector - xNg
// normVector - ʂ̖@xNg
// color - Ώە̐F
// s - ̋
// shadow - e̕ true
    public function getColor(viewVector:Vector3D,lightVector:Vector3D,
      	      	      	     normVector:Vector3D,color:uint,s:Number,
      	      	      	     shadow:Boolean):uint{
      var cd:Number=ke;
      var cs:Number=0.0;
      if(!shadow){
      	var rc:Number=-lightVector.dotProduct(normVector);
      	cd+=s*kd*Math.max(rc,0.0);
      	var reflect:Vector3D=new Vector3D
      	  (lightVector.x+2.0*rc*normVector.x,
      	   lightVector.y+2.0*rc*normVector.y,
      	   lightVector.z+2.0*rc*normVector.z);
      	rc=-reflect.dotProduct(viewVector);
      	cs=s*ks*Math.pow(Math.max(rc,0.0),ns);
      }
      cs*=255.0
      var rr:int=Math.min(int(cd*Number(0xFF&(color>>16))+cs),255);
      var gg:int=Math.min(int(cd*Number(0xFF&(color>>8))+cs),255);
      var bb:int=Math.min(int(cd*Number(0xFF&color)+cs),255);
      return (rr<<16)|(gg<<8)|bb;
    }
  }
}
