package{
  import figure.Point3D;

//--------------------------------------------------------------------//
// ԃNX
  public class InterPolation{

//--------------------------------------------------------------------//
// 3̓_`Ԃ_Ԃ
// p1,p2 - _1,2
// a1,a2- _1,2̌W
    public static function point(p1:Point3D,p2:Point3D,
      	      	      	      	 a1:int,a2:int):Point3D{
      if((a1+a2)==0){
      	return p1.copy();
      }
      else{
      	var cc:Number=Number(a1)/Number(a1+a2);
      	return new Point3D(p1.x+cc*(p2.x-p1.x),p1.y+cc*(p2.y-p1.y),
      	      	      	   p1.z+cc*(p2.z-p1.z));
      }
    }

//--------------------------------------------------------------------//
// `ԂFԂ
// c1,c2 - F1,2
// a1,a2 - F1,2̌W
    public static function color(c1:uint,c2:uint,a1:int,a2:int):uint{
      if((a1+a2)==0){
      	return c1;
      }
      else{
      	var cc:Number=Number(a1)/Number(a1+a2);
      	var r1:uint=0xFF&(c1>>16);
      	var g1:uint=0xFF&(c1>>8);
      	var b1:uint=0xFF&c1;
      	var r2:uint=0xFF&(c2>>16);
      	var g2:uint=0xFF&(c2>>8);
      	var b2:uint=0xFF&c2;
      	var r:int=Math.min(Math.max(r1+int(cc*Number(r2-r1)),0),255);
      	var g:int=Math.min(Math.max(g1+int(cc*Number(g2-g1)),0),255);
      	var b:int=Math.min(Math.max(b1+int(cc*Number(b2-b1)),0),255);
      	return (r<<16)|(g<<8)|b;
      }
    }

//--------------------------------------------------------------------//
// `ԂlԂ
// n - f[^_̐
// xp - ԈʒuxW
// x,y - f[^_x,yW̃Xg
    public static function linear(n:int,xp:Number,x:Vector.<Number>,
      	      	      	      	  y:Vector.<Number>):Number{
      if(xp<x[0]){
      	return y[0];
      }
      else if(xp>=x[n-1]){
      	return y[n-1];
      }
      else{
      	var low:int=0;
      	var high:int=n-1;
      	do{
      	  var mid:int=(low+high)/2;
      	  if(x[mid]<=xp)     low=mid+1;
      	  else if(x[mid]>xp) high=mid;
      	}while(low<high);
      	var i:int=(low+high)/2-1;
      	var cc:Number=(xp-x[i])/(x[i+1]-x[i]);
      	return y[i]+cc*(y[i+1]-y[i]);
      }
    }
  }
}
