package shading{
  import flash.geom.Vector3D;

//--------------------------------------------------------------------//
// o[fNX
  public class LambertModel implements LightModel{

// gUˌW
    protected var kd:Number;

// W
    protected var ke:Numbe;

//--------------------------------------------------------------------//
// o[f\z
// kd - gUˌW
// ke - W
    public function LambertModel(kd:Number,ke:Number):void{
      this.kd=kd;
      this.ke=ke;
    }

//--------------------------------------------------------------------//
// ˌvZĕ\FԂ
// viewVector - xNg
// lightVector - xNg
// normVector - ʂ̖@xNg
// color - Ώە̐F
// s - ̋
// shadow - e̕ true
    public function getColor(viewVector:Vector3D,lightVector:Vector3D,
      	      	      	     normVector:Vector3D,color:uint,s:Number,
      	      	      	     shadow:Boolean):uint{
      var cd:Number=ke;
      if(!shadow){
      	var rc:Number=-lightVector.dotProduct(normVector);
      	cd+=s*kd*Math.max(rc,0.0);
      }
      var rr:int=Math.min(int(cd*Number(0xFF&(color>>16))),255);
      var gg:int=Math.min(int(cd*Number(0xFF&(color>>8))),255);
      var bb:int=Math.min(int(cd*Number(0xFF&color)),255);
      return (rr<<16)|(gg<<8)|bb;
    }
  }
}
