package shading{
  import flash.display.BitmapData;
  import flash.geom.Vector3D;
  import figure.Point3D;
  import figure.Polygon3D;
  import figure.PolygonCollection;

//--------------------------------------------------------------------//
// VF[fBO̒ۃX[p[NX
  public class Shading{

// wIf
    public static const LIGHT_MODEL:LightModel
      =new PhongModel(0.7,0.7,20,0.4);

// ʕ
    protected var width:int;

// ʍ
    protected var height:int;

// _
    protected var viewPoint:Point3D;

// 
    protected var lightPoint:Point3D;

// ϊꍇ true
    protected var perspect:Boolean;

//--------------------------------------------------------------------//
// VF[fBO\z
// width,height - ʕE
// viewPoint - _
// lightPoint - 
// perspect - ϊꍇ true
    public function Shading(width:int,height:int,viewPoint:Point3D,
      	      	      	    lightPoint:Point3D,
      	      	      	    perspect:Boolean):void{
      this.width=width;
      this.height=height;
      this.viewPoint=viewPoint;
      this.lightPoint=lightPoint;
      this.perspect=perspect;
    }

//--------------------------------------------------------------------//
// |S̃VF[fBO`vZ
// pl - |S
// image - ʕ\摜
// zbuf - zW̃obt@Xg
    public function polygon(pl:Polygon3D,image:BitmapData,
      	      	      	    zbuf:Array):void{
    }

//--------------------------------------------------------------------//
// |SW̃VF[fBO`vZ
// pc - |SW
// image - ʕ\摜
// zbuf - zW̃obt@Xg
    public function polygons(pc:PolygonCollection,image:BitmapData,
      	      	      	     zbuf:Array):void{
      var n:int=pc.getCount();
      for(var i:int=0;i<n;i++){
      	polygon(pc.getPolygon(i),image,zbuf);
      }
    }

//--------------------------------------------------------------------//
// [hWʍWɕϊ_Ԃ
// p - ϊO̓_
    protected function screen(p:Point3D):Point3D{
      var viewVector:Vector3D=new Vector3D
      	(viewPoint.x,viewPoint.y,viewPoint.z);
      var d1:Number=viewVector.length;
      viewVector.normalize();
      var p2:Point3D=p.copy();
      var d2:Number=viewVector.x*viewVector.x+viewVector.y*viewVector.y;
      if(d2>Number.MIN_VALUE){
      	d2=Math.sqrt(d2);
      	var cc:Number=-viewVector.y/d2;
      	var ss:Number=-viewVector.x/d2;
      	var tx:Number=cc*p2.x-ss*p2.y;
      	var ty:Number=ss*p2.x+cc*p2.y;
      	p2.x=tx;
      	p2.y=ty;
      	ty=viewVector.z*p2.y+d2*p2.z;
      	var tz:Number=-d2*p2.y+viewVector.z*p2.z;
      	p2.y=ty;
      	p2.z=tz;
      }
      if(perspect){
      	d1=1.0-p2.z/d1;
      	return new Point3D(0.5*width+p2.x/d1,
      	      	      	   0.5*height-p2.y/d1,p2.z);
      }
      else{
      	return new Point3D(0.5*width+p2.x,
      	      	      	   0.5*height-p2.y,p2.z);
      }
    }
  }
}
